/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.batch.protocol.models;


/**
 * How the Batch service should respond to a particular exit condition.
 */
public class ExitOptions {
    /**
     * An action to take on the job containing the task, if the task completes
     * with the given exit condition and the job’s onTaskFailed property is
     * 'performexitoptionsjobaction'. Possible values include: 'none',
     * 'disable', 'terminate'.
     */
    private JobAction jobAction;

    /**
     * Get the jobAction value.
     *
     * @return the jobAction value
     */
    public JobAction jobAction() {
        return this.jobAction;
    }

    /**
     * Set the jobAction value.
     *
     * @param jobAction the jobAction value to set
     * @return the ExitOptions object itself.
     */
    public ExitOptions withJobAction(JobAction jobAction) {
        this.jobAction = jobAction;
        return this;
    }

}
