/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.management.graphrbac.implementation;

import org.joda.time.DateTime;

/**
 * Active Directory PasswordCredential information.
 */
public class PasswordCredentialInner {
    /**
     * start date.
     */
    private DateTime startDate;

    /**
     * end date.
     */
    private DateTime endDate;

    /**
     * key Id.
     */
    private String keyId;

    /**
     * value.
     */
    private String value;

    /**
     * Get the startDate value.
     *
     * @return the startDate value
     */
    public DateTime startDate() {
        return this.startDate;
    }

    /**
     * Set the startDate value.
     *
     * @param startDate the startDate value to set
     * @return the PasswordCredentialInner object itself.
     */
    public PasswordCredentialInner withStartDate(DateTime startDate) {
        this.startDate = startDate;
        return this;
    }

    /**
     * Get the endDate value.
     *
     * @return the endDate value
     */
    public DateTime endDate() {
        return this.endDate;
    }

    /**
     * Set the endDate value.
     *
     * @param endDate the endDate value to set
     * @return the PasswordCredentialInner object itself.
     */
    public PasswordCredentialInner withEndDate(DateTime endDate) {
        this.endDate = endDate;
        return this;
    }

    /**
     * Get the keyId value.
     *
     * @return the keyId value
     */
    public String keyId() {
        return this.keyId;
    }

    /**
     * Set the keyId value.
     *
     * @param keyId the keyId value to set
     * @return the PasswordCredentialInner object itself.
     */
    public PasswordCredentialInner withKeyId(String keyId) {
        this.keyId = keyId;
        return this;
    }

    /**
     * Get the value value.
     *
     * @return the value value
     */
    public String value() {
        return this.value;
    }

    /**
     * Set the value value.
     *
     * @param value the value value to set
     * @return the PasswordCredentialInner object itself.
     */
    public PasswordCredentialInner withValue(String value) {
        this.value = value;
        return this;
    }

}
