/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.management.network;

import java.util.List;

/**
 * Application gateway SSL policy.
 */
public class ApplicationGatewaySslPolicy {
    /**
     * SSL protocols to be disabled on Application Gateway.
     */
    private List<ApplicationGatewaySslProtocol> disabledSslProtocols;

    /**
     * Get the disabledSslProtocols value.
     *
     * @return the disabledSslProtocols value
     */
    public List<ApplicationGatewaySslProtocol> disabledSslProtocols() {
        return this.disabledSslProtocols;
    }

    /**
     * Set the disabledSslProtocols value.
     *
     * @param disabledSslProtocols the disabledSslProtocols value to set
     * @return the ApplicationGatewaySslPolicy object itself.
     */
    public ApplicationGatewaySslPolicy withDisabledSslProtocols(List<ApplicationGatewaySslProtocol> disabledSslProtocols) {
        this.disabledSslProtocols = disabledSslProtocols;
        return this;
    }

}
