/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.management.network.implementation;

import java.util.List;
import com.microsoft.azure.management.network.ExpressRouteCircuitRoutesTable;

/**
 * Response for ListRoutesTable associated with the Express Route Circuits Api.
 */
public class ExpressRouteCircuitsRoutesTableListResultInner {
    /**
     * Gets List of RoutesTable.
     */
    private List<ExpressRouteCircuitRoutesTable> value;

    /**
     * Gets the URL to get the next set of results.
     */
    private String nextLink;

    /**
     * Get the value value.
     *
     * @return the value value
     */
    public List<ExpressRouteCircuitRoutesTable> value() {
        return this.value;
    }

    /**
     * Set the value value.
     *
     * @param value the value value to set
     * @return the ExpressRouteCircuitsRoutesTableListResultInner object itself.
     */
    public ExpressRouteCircuitsRoutesTableListResultInner withValue(List<ExpressRouteCircuitRoutesTable> value) {
        this.value = value;
        return this;
    }

    /**
     * Get the nextLink value.
     *
     * @return the nextLink value
     */
    public String nextLink() {
        return this.nextLink;
    }

    /**
     * Set the nextLink value.
     *
     * @param nextLink the nextLink value to set
     * @return the ExpressRouteCircuitsRoutesTableListResultInner object itself.
     */
    public ExpressRouteCircuitsRoutesTableListResultInner withNextLink(String nextLink) {
        this.nextLink = nextLink;
        return this;
    }

}
