/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.management.search.implementation;

import java.util.Map;
import com.microsoft.azure.management.search.SearchServiceProperties;

/**
 * Properties that describe an Azure Search service.
 */
public class SearchServiceCreateOrUpdateParametersInner {
    /**
     * The geographic location of the Search service.
     */
    private String location;

    /**
     * Tags to help categorize the Search service in the Azure Portal.
     */
    private Map<String, String> tags;

    /**
     * Properties of the Search service.
     */
    private SearchServiceProperties properties;

    /**
     * Get the location value.
     *
     * @return the location value
     */
    public String location() {
        return this.location;
    }

    /**
     * Set the location value.
     *
     * @param location the location value to set
     * @return the SearchServiceCreateOrUpdateParametersInner object itself.
     */
    public SearchServiceCreateOrUpdateParametersInner withLocation(String location) {
        this.location = location;
        return this;
    }

    /**
     * Get the tags value.
     *
     * @return the tags value
     */
    public Map<String, String> tags() {
        return this.tags;
    }

    /**
     * Set the tags value.
     *
     * @param tags the tags value to set
     * @return the SearchServiceCreateOrUpdateParametersInner object itself.
     */
    public SearchServiceCreateOrUpdateParametersInner withTags(Map<String, String> tags) {
        this.tags = tags;
        return this;
    }

    /**
     * Get the properties value.
     *
     * @return the properties value
     */
    public SearchServiceProperties properties() {
        return this.properties;
    }

    /**
     * Set the properties value.
     *
     * @param properties the properties value to set
     * @return the SearchServiceCreateOrUpdateParametersInner object itself.
     */
    public SearchServiceCreateOrUpdateParametersInner withProperties(SearchServiceProperties properties) {
        this.properties = properties;
        return this;
    }

}
