/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 */

package com.microsoft.azure.management.search.implementation;

import java.util.Map;
import com.microsoft.azure.management.search.SearchServiceReadableProperties;
import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * Describes an Azure Search service and its current state.
 */
public class SearchServiceResourceInner {
    /**
     * The resource Id of the Azure Search service.
     */
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private String id;

    /**
     * The name of the Search service.
     */
    private String name;

    /**
     * The geographic location of the Search service.
     */
    private String location;

    /**
     * Tags to help categorize the Search service in the Azure Portal.
     */
    private Map<String, String> tags;

    /**
     * Properties of the Search service.
     */
    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    private SearchServiceReadableProperties properties;

    /**
     * Get the id value.
     *
     * @return the id value
     */
    public String id() {
        return this.id;
    }

    /**
     * Get the name value.
     *
     * @return the name value
     */
    public String name() {
        return this.name;
    }

    /**
     * Set the name value.
     *
     * @param name the name value to set
     * @return the SearchServiceResourceInner object itself.
     */
    public SearchServiceResourceInner withName(String name) {
        this.name = name;
        return this;
    }

    /**
     * Get the location value.
     *
     * @return the location value
     */
    public String location() {
        return this.location;
    }

    /**
     * Set the location value.
     *
     * @param location the location value to set
     * @return the SearchServiceResourceInner object itself.
     */
    public SearchServiceResourceInner withLocation(String location) {
        this.location = location;
        return this;
    }

    /**
     * Get the tags value.
     *
     * @return the tags value
     */
    public Map<String, String> tags() {
        return this.tags;
    }

    /**
     * Set the tags value.
     *
     * @param tags the tags value to set
     * @return the SearchServiceResourceInner object itself.
     */
    public SearchServiceResourceInner withTags(Map<String, String> tags) {
        this.tags = tags;
        return this;
    }

    /**
     * Get the properties value.
     *
     * @return the properties value
     */
    public SearchServiceReadableProperties properties() {
        return this.properties;
    }

}
